import React, { Dispatch, SetStateAction, useState, useEffect } from "react";
import { TezosToolkit } from "@taquito/taquito";
import { BeaconWallet } from "@taquito/beacon-wallet";


const BuyButton = ({
    Tezos,
    FA2address,
    sender,
    receiver,
    amount
}: {
    Tezos: TezosToolkit,
    FA2address: string,
    sender: string,
    receiver: string,
    amount: number
}): JSX.Element => {

    const makePayment = async (): Promise<void> => {
	const contract = await Tezos.wallet.at(FA2address);
	
        const transfer_params = [
            {
                from_: sender,
                txs: [{
                    to_: receiver,
                    token_id:0,
                    amount: amount
                }]
            }
        ];
        
        const op = await contract.methods.transfer(transfer_params).send();
        await op.confirmation();
    }
    
    return (
        <div className="buttons">
            <button
	className="myButton"
	onClick={makePayment}
	    >Transfer {amount}&nbsp;
	    µ-tokens from: &nbsp;
	    {sender}
	    &nbsp;to:&nbsp;
	    {receiver}
            </button>
        </div>
    );
};

export default BuyButton; 
